/******************************************************************/
/*                           PRNT_ACC.C                           */
/*                          version  2.13                         */
/*                  printer initialization accessory              */
/*								  */
/*                     compiled with MEGAMAX_C                    */
/*			 kenn johnson 6/30/87 			  */
/******************************************************************/

#include <obdefs.h>
#include <gemdefs.h>
#include <osbind.h>

/*************************************/
/* header file from RSC construction */
/*************************************/
#define FILENAME "PRINTER.RSC"	/* name of RSC-file */
#define PRNTRSET 0
#define EXIT 2
#define PICAON 19
#define ELITEON 20
#define LPI6 15
#define LPI8 16
#define TAB4 12
#define TAB8 13
#define DRAFTON 9
#define NLQON 10
#define CONDOFF 6
#define CONDON 7
#define ITALOFF 3
#define ITALON 4
/*************************/
/* miscellaneous defines */
/*************************/

#define FALSE 0	
#define TRUE 1		
#define ON 0x1
#define OFF 0x0
#define DONE 0xff

OBJECT *tree;

/******************************************/
/* escape codes for EPSON and compatibles */
/******************************************/

#define ESC 0x1b			/* escape 		 */
#define CONDENSE 0x0f		/* condensed 	 */
#define STANDARD 0x12		/* condensed off */
#define ELITE 0x4d			/* elite		 */
#define ELITEOFF 0x50		
#define ITALIC 0x34			/* italic		 */
#define ITALICOFF 0x35	
#define NLQ 0x78			/* NLQ on		 */
#define MARGSET 0x51		/* right margin set */
#define RMARG 0x50			/* 80 decimal */
#define TABSET 0x65
#define HTAB 0
#define SIX 0x32			/* lines per inch */
#define EIGHT 0x30
/********************/
/* global variables */
/********************/

int contrl[12];			/* control-arrays */
int intin[128];
int ptsin[128];
int intout[128];
int ptsout[128];		/* reserve space for all parameters */
int pxyarray[12];		/* arrary for x,y coordinates */

int work_in[11];		/* input in GSX array */
int work_out[57];		/* output from GSX array */

int handle;				/* virtual workstation handle */
int phys_handle;		/* physical workstation handle */

int ap_id;				/* code number of application */

int menu_id;

int gl_hchar, gl_wchar;			/* height and width of character */
int gl_wbox, gl_hbox;

int xdesk,ydesk,wdesk,hdesk;	/* desktop dimensions */
int xobj,yobj,wobj,hobj;	/* coordinates of objects */

int event;			/* which event occured */
int msgbuff[8];

int dummy;			/* a place to store unused parameters  */

char string[25];		/* where we store it before sent to printer */

int end;

int keycode;
int mx,my;
int ret;

/******************************/
/*  open virtual workstation  */
/******************************/

open_vwork()
{
int i;
	for (i=0;i<10;work_in[i++]=1);
	work_in[10]=2;
	handle=phys_handle;
	v_opnvwk(work_in,&handle,work_out);
}

/****************/
/* main program */
/****************/

main()
{
long gemdos();
		ap_id=appl_init();	
		phys_handle=graf_handle(&gl_wchar,&gl_hchar,&gl_wbox,&gl_hbox);
		menu_id=menu_register(ap_id,"  PRINTER_SET");
		wind_get(0,WF_WORKXYWH,&xdesk,&ydesk,&wdesk,&hdesk);
		open_vwork();

			if(!rsrc_load(FILENAME)){
				form_alert(1,"[3] |PRINTER.RSC| not found][EXIT]");
				}

	while (TRUE) {
		event=evnt_multi (MU_MESAG | MU_BUTTON | MU_KEYBD,
			1,1,1,
			0,0,0,0,0,
			0,0,0,0,0,
			msgbuff,0,0,&mx,&my,&ret,&ret,
			&keycode,&ret);

	if (event & MU_MESAG)
		switch (msgbuff[0]) {

			case AC_OPEN:
				if (msgbuff[4] == menu_id) {
					output();
					v_clsvwk(handle);
				}
				break;
			}
		}
}

output()
{
		while (!Cprnos())
		{
			form_alert(1,"[3][ |Printer not|   READY][OK]");
				if(!Cprnos())
				return(0);  
		}	

		rsrc_gaddr(R_TREE,PRNTRSET,&tree);

		clear_rsc();
	
		form_center(tree,&xobj,&yobj,&wobj,&hobj);
		form_dial(FMD_START,dummy,dummy,dummy,dummy,xobj,yobj,wobj,hobj);
		form_dial(FMD_GROW,0,10,100,50,xobj,yobj,wobj,hobj);

		objc_draw(tree,0,MAX_DEPTH,0,0,wdesk,hdesk);

		end=FALSE;


	while (end != TRUE){
		do_it();
	}

	form_dial(FMD_FINISH,dummy,dummy,dummy,dummy,xobj,yobj,wobj,hobj);
	form_dial(FMD_SHRINK,0,10,100,50,xobj,yobj,wobj,hobj);
}

do_it()
{
	form_do(tree,0);

		if (tree[ELITEON].ob_state == SELECTED){
			string [0]=ESC;
			string [1]=ELITE;
			}

		else if (tree[PICAON].ob_state == SELECTED){
			string [0]=ESC;
			string [1]=ELITEOFF;
			}
	
		if (tree[CONDON].ob_state == SELECTED){
			string [2]=CONDENSE;
			string [3]=ESC;
			string [4]=MARGSET;
				if (tree[ELITEON].ob_state == SELECTED)
					string [5]=(RMARG + 80);
				else
					string [5]=(RMARG + 56);
			}

		else if (tree[CONDOFF].ob_state == SELECTED){
			string [2]=STANDARD;
			string [3]=ESC;
			string [4]=MARGSET;
				if (tree[ELITEON].ob_state == SELECTED)
					string [5]=(RMARG + 16);
				else
					string [5]=RMARG;
			}

		if (tree[ITALON].ob_state == SELECTED){
			string [6]=ESC;
			string [7]=ITALIC;
			}

		else if (tree[ITALOFF].ob_state == SELECTED){
			string [6]=ESC;
			string [7]=ITALICOFF;
			}

		if (tree[NLQON].ob_state == SELECTED){
			string [8]=ESC;
			string [9]=NLQ;
			string [10]=ON;
			}

		else if (tree[DRAFTON].ob_state == SELECTED){
			string [8]=ESC;
			string [9]=NLQ;
			string [10]=OFF;
			}

		if (tree[TAB4].ob_state == SELECTED){
			string [11]=ESC;
			string [12]=TABSET;
			string [13]=HTAB;
			string [14]=(HTAB + 4);
			}

		else if (tree[TAB8].ob_state == SELECTED){
			string [11]=ESC;
			string [12]=TABSET;
			string [13]=HTAB;
			string [14]=(HTAB + 8);
			}					

		if (tree[LPI6].ob_state == SELECTED){
			string [15]=ESC;
			string [16]=SIX;
			}
			
		else if (tree[LPI8].ob_state == SELECTED){
			string [15]=ESC;
			string [16]=EIGHT;
			}

		if (tree[EXIT].ob_state == SELECTED){
			string [17]=DONE;
			print_it();
			end=TRUE;
			
			}


	}				/* end do_it */

	/* end main */

print_it()
{
#define YES 1

int c;
int fini;
	while(fini != YES){
		for(c=0; c<25; c++){
			if(string[c] == DONE);
				fini = YES;
			Cprnout(string[c]);
		}
	}
}

clear_rsc()
{
	tree[EXIT].ob_state &= ~SELECTED;
	tree[ELITEON].ob_state |= SELECTED;
	tree[ITALOFF].ob_state |= SELECTED;
	tree[CONDOFF].ob_state |= SELECTED;
	tree[DRAFTON].ob_state |= SELECTED;
	tree[TAB4].ob_state |= SELECTED;
	tree[PICAON].ob_state &= ~SELECTED;
	tree[ITALON].ob_state &= ~SELECTED;
	tree[CONDON].ob_state &= ~SELECTED;
	tree[NLQON].ob_state &= ~SELECTED;
	tree[TAB8].ob_state &= ~SELECTED;
	tree[LPI6].ob_state |= SELECTED;
	tree[LPI8].ob_state &= ~SELECTED;
}
