; Convert Commodore 64 KOALA pictures to Low-Res ST
; ***** Jerry Bethel  July 22, 1987 *****
; get the pointers to the KOALA data and output screen area
init0:
   move.l  6(sp),a0
   lea     init0,a1
   cmp.l   0(a0),a1          ; Old version parm list?
   beq     init1             ; Yes, go process
   move.l  0(a0),a1          ; New version parm offsets
   move.l  4(a0),a4          ; (Same as Atari ST-Basic)
   bra     init2
init1:
   move.l  4(a0),a1          ; Old parm offsets
   move.l  8(a0),a4
init2:
   cmp.w   #$0400,0(a1)
   bne     init3
   lea     6(a1),a1
init3:
   cmp.w   #$0060,0(a1)
   beq     init4
   lea     511(a1),a1
init4:
   lea     2(a1),a1          ; a1 -> bitmap data
   lea     8000(a1),a2       ; a2 -> "screen" data
   lea     1000(a2),a3       ; a3 -> color data
   lea     colors,a6
   clr.l   d0
   move.b  1000(a3),d0       ; background color
   andi.b  #$f,d0
   move.w  d0,0(a6)
   lsl.w   #4,d0
   or.w    d0,0(a6)
;
   move.l  #24,d5
main00:
   move.l  d5,-(sp)
   move.l  #19,d5
main10:
   jsr     put_screen
   jsr     put_screen
   addq.l  #8,a4
   dbf     d5,main10
   add.w   #1120,a4
   move.l  (sp)+,d5
   dbf     d5,main00
   rts
;
; take 8 bytes of bitmap and re-arrange to ST format
put_screen:
   move.l  a4,a5
   jsr     get_color
   moveq.l #7,d6
put_screen10:
   move.b  (a1)+,d2
   jsr     expand
   add.w   #160,a5
   dbf     d6,put_screen10
   rts
;
; takes the byte in d2 and expands it into the words at a5
expand:
   moveq.l #3,d7
expand00:
   clr.l   d1
   lsl.b   #1,d2
   roxl.b  #1,d1
   lsl.b   #1,d2
   roxl.b  #2,d1
   move.w  0(a6,d1),d4
   jsr     expand10
   jsr     expand10
   dbf     d7,expand00
   rts
expand10:
   lsr.b   #1,d4
   roxl.w  0(a5)
   lsr.b   #1,d4
   roxl.w  2(a5)
   lsr.b   #1,d4
   roxl.w  4(a5)
   lsr.b   #1,d4
   roxl.w  6(a5)
   rts
;
; puts the color values into the words at "colors:"
get_color:
   clr.l   d0
   move.b  (a2)+,d0
   move.l  d0,d1
   andi.w  #$f,d0
   move.w  d0,4(a6)
   lsl.w   #4,d0
   or.w    d0,4(a6)
;
   andi.w  #$f0,d1
   move.w  d1,2(a6)
   lsr.w   #4,d1
   or.w    d1,2(a6)
;
   move.b  (a3)+,d0
   andi.w  #$f,d0
   move.w  d0,6(a6)
   lsl.w   #4,d0
   or.w    d0,6(a6)
   rts
;
colors:
   dc.w    0,1,2,3
   end
