;
;	*** DESCOLOR ***
;
;	Author:	M. Livenspargar
;	Written with A-SEKA assembler
;
;	Fire this baby up and see your desktop change color.  Gee whiz!
;	Hi-res not affected.
;

	gemdos		= 1

	super		= $20
	ptermres 	= $31

	vbl_list 	= $4ce
	prt_cnt		= $4ee
	color2		= $ff8244

	delay		= 8

start:
	move.l	$4(sp),a0					; get basepage address
	move.l	#$100,d6					; length of basepage
	add.l	$C(a0),d6					; program length
	add.l	$14(a0),d6					; data length
	add.l	$1C(a0),d6					; bss length

	clr.l	-(sp)						; supervisor stack becomes user stack
	move.w	#super,-(sp)				; enter supervisor mode
	trap	#gemdos						; now
	addq.l	#6,sp						; clean up stack
	move.l	#vbl_list,a0				; put start of vbl queue in a0

scanq:
	tst.l	(a0)						; current queue entry empty?
	beq.s	newvbl						; yes, install new vbl routine
	addq.l	#4,a0						; no, check next entry
	bra.s	scanq						; loop back

newvbl:
	move.l	#myvbl,a1					; address of new vbl routine
	move.l	a1,(a0)						; install routine in queue
	move.w	#0,flag1					; clear delay flag
	move.l	d0,-(sp)					; old supervisor stack pointer
	move.w	#super,-(sp)				; return to user mode
	trap	#gemdos						; now
	addq.l	#6,sp						; clean up stack

	clr.w	-(sp)						; no error code
	move.l	d6,-(sp)					; reserve this amount of space
	move.w	#ptermres,-(sp)				; terminate processing
	trap	#gemdos						; now

myvbl:
	addq.b	#delay,flag1				; add delay factor
	bne.s	exit						; change color only on zero
	addq.w	#1,color2					; alter color

exit:
	rts									; return

flag1:
	blk.w 1
