          TEXT
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; A program to set the printer configuration for
; a 960 dots per inch printer, e.g., Epson et. al.
; Put this program in the AUTO folder and the Atari
; CONTROL.ACC can be removed if you have another
; mechanism, such as a battery driven clock, to
; replace the time function.
; Program written by Merlin Hanson and placed in
; public domain 2/28/88.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
          INCLUDE   d:\assempro\gemmacro\gemdos.s
main:
          move.w    #%000100,-(sp)      ; 'Internals' has mono/color
                                        ; backwards, of course!
          move.w    #33,-(sp)           ; setprt call
          trap      #14                 ; xbios
          add.l     #4,sp               ; fix stack
          bsr       print_message
          term
          ;---------------------------------------
print_message:
          printline msg1                ; message to the screen
          clr.l     time_delay
loop:
          add.l     #1,time_delay
          cmp.l     #200000,time_delay  ; about a 2 second delay to let the
             ; user read the message before TOS erases the screen.
          bne       loop
          rts
          ;###############################################
          DATA
msg1      dc.b   27,'E'                 ; VT-52. clear, home
          dc.b   27,'Y',32+10,32+20     ; cursor to line 10, column 20
          dc.b   'The printer is set for 960 dots per inch.',0
          ALIGN
          BSS
time_delay  ds.l   1
          END
